"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var PineconeModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.PineconeModule = void 0;
const common_1 = require("@nestjs/common");
const axios_1 = require("@nestjs/axios");
const service_1 = require("./service");
const interface_1 = require("./interface");
let PineconeModule = PineconeModule_1 = class PineconeModule {
    static register(config) {
        return {
            module: PineconeModule_1,
            imports: [axios_1.HttpModule],
            providers: [
                {
                    provide: interface_1.PINECONE_CONFIG,
                    useValue: config,
                },
                service_1.PineconeIndexService,
                service_1.PineconeVectorService,
            ],
            exports: [service_1.PineconeIndexService, service_1.PineconeVectorService],
        };
    }
    static registerAsync(options) {
        return {
            module: PineconeModule_1,
            imports: [axios_1.HttpModule, ...options.imports],
            providers: [
                {
                    provide: interface_1.PINECONE_CONFIG,
                    useFactory: options.useFactory,
                    inject: options.inject || [],
                },
                service_1.PineconeIndexService,
                service_1.PineconeVectorService,
                ...(options.extraProviders || []),
            ],
            exports: [service_1.PineconeIndexService, service_1.PineconeVectorService],
        };
    }
};
PineconeModule = PineconeModule_1 = __decorate([
    (0, common_1.Module)({
        providers: [service_1.PineconeIndexService, service_1.PineconeVectorService],
    })
], PineconeModule);
exports.PineconeModule = PineconeModule;
//# sourceMappingURL=pinecone.module.js.map