import { HttpService } from '@nestjs/axios';
import { Observable } from 'rxjs';
import { IndexDescriptionResult, PineconeConfig, WhoAmIResult } from '../interface';
export declare class PineconeIndexService {
    private readonly config;
    private readonly httpService;
    constructor(config: PineconeConfig, httpService: HttpService);
    /**
     * HttpService config
     * @private
     */
    private _conf;
    private url;
    /**
     * Check environment and make sure your Pinecone API key works.
     */
    whoAmI(): Observable<WhoAmIResult>;
    /**
     * This operation returns a list of your Pinecone indexes.
     */
    listIndexes(): Observable<string[]>;
    /**
     * Get a description of an index.
     * @param indexName or default index set in config
     */
    describeIndex(indexName?: string): Observable<IndexDescriptionResult>;
}
