"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PineconeIndexService = void 0;
const common_1 = require("@nestjs/common");
const axios_1 = require("@nestjs/axios");
const rxjs_1 = require("rxjs");
const interface_1 = require("../interface");
let PineconeIndexService = class PineconeIndexService {
    constructor(config, httpService) {
        this.config = config;
        this.httpService = httpService;
        this._conf = {
            headers: {
                'Api-Key': this.config.apiKey,
                'Content-Type': 'application/json',
            },
        };
    }
    url(target) {
        return `https://controller.${this.config.environment}.pinecone.io${target}`;
    }
    /**
     * Check environment and make sure your Pinecone API key works.
     */
    whoAmI() {
        return this.httpService
            .get(this.url('/actions/whoami'), this._conf)
            .pipe((0, rxjs_1.map)((axiosResponse) => {
            return axiosResponse.data;
        }));
    }
    /**
     * This operation returns a list of your Pinecone indexes.
     */
    listIndexes() {
        return this.httpService
            .get(this.url(`/databases`), this._conf)
            .pipe((0, rxjs_1.map)((axiosResponse) => {
            return axiosResponse.data;
        }));
    }
    /**
     * Get a description of an index.
     * @param indexName or default index set in config
     */
    describeIndex(indexName) {
        return this.httpService
            .get(this.url(`/databases/${indexName ? indexName : this.config.index}`), this._conf)
            .pipe((0, rxjs_1.map)((axiosResponse) => {
            return axiosResponse.data;
        }));
    }
};
PineconeIndexService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(interface_1.PINECONE_CONFIG)),
    __metadata("design:paramtypes", [Object, axios_1.HttpService])
], PineconeIndexService);
exports.PineconeIndexService = PineconeIndexService;
//# sourceMappingURL=pinecone.index.service.js.map